package Api

import (
	"encoding/json"
	"net/url"
	"reflect"
	"sort"
	"strings"

	"github.com/labstack/echo"
	"github.com/sunmi-OS/gocore/utils"
)

type PrintTicket struct{}

func PrintTicketHandelr() *PrintTicket{
	return &PrintTicket{}
}

//获取订单列表
func (pt *PrintTicket) GetPrintTicketOrderId(c echo.Context) error {
	reqMethod := c.Request().Method
	var params url.Values
	c.Request().ParseForm()
	if reqMethod == "GET" {
		params = c.Request().Form
	}else{
		params = c.Request().PostForm
	}
	//拼接调用业务接口的请求参数
	requestParams := ""
	for k, v := range params {
		if k != "sign" && k != "app_id" {
			requestParams += k + "=" + v[0] + "&"
		}
	}
	if requestParams != "" {
		requestParams = requestParams[:len(requestParams) - 1]
	}
	paramNames := c.ParamNames()
	if len(paramNames) > 0 {
		paramValues := c.ParamValues()
		for k, v := range paramNames {
			params[v] = []string{paramValues[k]}
		}
	}
	//判断 appId 参数是否存在
	if len(params["app_id"]) == 0 {
		return Response(c,"-1","","Missing app_id")
	}
	appId := params["app_id"][0]
	if appId != "商米提供的app_id" {
		return Response(c, "-1", "", "invalid app_id")
	}

	//判断签名参数是否存在
	if len(params["sign"]) == 0 {
		return Response(c, "-1", "", "Missing sign")
	}
	//校验签名
	var keys []string
	var formData = make(url.Values)
	for k, v := range params {
		if reflect.TypeOf(v[0]).String() != "string" {
			return Response(c, "-1", "", "Invalid parameter")
		}
		keys = append(keys, k)
		if k != "app_id" && k != "sign" {
			formData[k] = []string{v[0]}
		}
	}
	sort.Strings(keys)
	var stringSignTemp string = ""
	for _, k := range keys {
		if k != "sign" {
			stringSignTemp += k + "=" + params[k][0] + "&"
		}
	}
	stringSignTemp = stringSignTemp[:len(stringSignTemp) - 1]
	stringSignTemp = stringSignTemp + "商米提供的app_key"
	sign := params["sign"][0]
	realSign := strings.ToUpper(utils.GetMD5(stringSignTemp))
	if sign != realSign { //签名是否正确
		return Response(c, "-1", "", "Invalid sign")
	}

	//Todo 查询数据库中订单状态为 未打印的订单id，按时间先后顺序，取最先入库的5条返回， 不足5条 有多少返回多少

	listDemo := map[int][]string {
		1: []string{"1", "2", "3", "4", "5"},
		2: []string{"6"},
		3: []string{"7", "8", "9", "10"},
		4: []string{"11", "12", "13"},
	}

	r := utils.RandInt(1, 4)

	return Response(c, "1", listDemo[r], "")
}

//获取订单详情
func (pt *PrintTicket) GetPrintTicketInfo(c echo.Context) error {
	reqMethod := c.Request().Method
	var params url.Values
	c.Request().ParseForm()
	if reqMethod == "GET" {
		params = c.Request().Form
	}else{
		params = c.Request().PostForm
	}
	//拼接调用业务接口的请求参数
	requestParams := ""
	for k, v := range params {
		if k != "sign" && k != "app_id" {
			requestParams += k + "=" + v[0] + "&"
		}
	}
	if requestParams != "" {
		requestParams = requestParams[:len(requestParams) - 1]
	}
	paramNames := c.ParamNames()
	if len(paramNames) > 0 {
		paramValues := c.ParamValues()
		for k, v := range paramNames {
			params[v] = []string{paramValues[k]}
		}
	}
	//判断 appId 参数是否存在
	if len(params["app_id"]) == 0 {
		return Response(c,"-1","","Missing app_id")
	}
	appId := params["app_id"][0]
	if appId != "商米提供的app_id" {
		return Response(c, "-1", "", "invalid app_id")
	}

	//判断签名参数是否存在
	if len(params["sign"]) == 0 {
		return Response(c, "-1", "", "Missing sign")
	}
	//校验签名
	var keys []string
	var formData = make(url.Values)
	for k, v := range params {
		if reflect.TypeOf(v[0]).String() != "string" {
			return Response(c, "-1", "", "Invalid parameter")
		}
		keys = append(keys, k)
		if k != "app_id" && k != "sign" {
			formData[k] = []string{v[0]}
		}
	}
	sort.Strings(keys)
	var stringSignTemp string = ""
	for _, k := range keys {
		if k != "sign" {
			stringSignTemp += k + "=" + params[k][0] + "&"
		}
	}
	stringSignTemp = stringSignTemp[:len(stringSignTemp) - 1]
	stringSignTemp = stringSignTemp + "商米提供的app_key"
	sign := params["sign"][0]
	realSign := strings.ToUpper(utils.GetMD5(stringSignTemp))
	if sign != realSign { //签名是否正确
		return Response(c, "-1", "", "Invalid sign")
	}

	//Todo 根据订单id 查询数据库中订单详情并返回

	data := map[string]interface{}{
		"voice"   : "打印打印",
		"data"    : "1b2130e6b58be8af95e68993e58db0e7a5a8e68dae416263640a",
		"orderId" : "订单id",
	}

	return Response(c, "1", data, "")
}

//更新订单状态
func (pt *PrintTicket) UpdatePrintTicketStatus(c echo.Context) error {
	reqMethod := c.Request().Method
	var params url.Values
	c.Request().ParseForm()
	if reqMethod == "GET" {
		params = c.Request().Form
	}else{
		params = c.Request().PostForm
	}
	//拼接调用业务接口的请求参数
	requestParams := ""
	for k, v := range params {
		if k != "sign" && k != "app_id" {
			requestParams += k + "=" + v[0] + "&"
		}
	}
	if requestParams != "" {
		requestParams = requestParams[:len(requestParams) - 1]
	}
	paramNames := c.ParamNames()
	if len(paramNames) > 0 {
		paramValues := c.ParamValues()
		for k, v := range paramNames {
			params[v] = []string{paramValues[k]}
		}
	}
	//判断 appId 参数是否存在
	if len(params["app_id"]) == 0 {
		return Response(c,"-1","","Missing app_id")
	}
	appId := params["app_id"][0]
	if appId != "商米提供的app_id" {
		return Response(c, "-1", "", "invalid app_id")
	}

	//判断签名参数是否存在
	if len(params["sign"]) == 0 {
		return Response(c, "-1", "", "Missing sign")
	}
	//校验签名
	var keys []string
	var formData = make(url.Values)
	for k, v := range params {
		if reflect.TypeOf(v[0]).String() != "string" {
			return Response(c, "-1", "", "Invalid parameter")
		}
		keys = append(keys, k)
		if k != "app_id" && k != "sign" {
			formData[k] = []string{v[0]}
		}
	}
	sort.Strings(keys)
	var stringSignTemp string = ""
	for _, k := range keys {
		if k != "sign" {
			stringSignTemp += k + "=" + params[k][0] + "&"
		}
	}
	stringSignTemp = stringSignTemp[:len(stringSignTemp) - 1]
	stringSignTemp = stringSignTemp + "商米提供的app_key"
	sign := params["sign"][0]
	realSign := strings.ToUpper(utils.GetMD5(stringSignTemp))
	if sign != realSign { //签名是否正确
		return Response(c, "-1", "", "Invalid sign")
	}

	//Todo 查询数据库，将订单状态修改为已打印

	return Response(c, "1", "success", "")
}

func Response(c echo.Context, code string, data interface{}, msg string) error {
	resData := make(map[string]interface{})
	resData["code"] = code
	resData["data"] = data
	resData["msg"] = msg
	//返回消息
	b, _ := json.Marshal(resData)
	return c.String(200, string(b))
}