package Domain

import (
	"encoding/json"

	"github.com/labstack/echo"
	"github.com/sunmi-OS/gocore/log"
	"go.uber.org/zap"
)

//统一接口返回格式
func Response(c echo.Context, code string, data interface{}, msg string) error {
	resData := make(map[string]interface{})
	resData["code"] = code
	resData["data"] = data
	resData["msg"] = msg
	log.InitLogger("go-test-api")
	var args = make(map[string]interface{})
	args["api"] = c.Path()
	args["request"] = c.Request().PostForm
	args["response"] = resData
	log.Sugar.Infow("go-test-api", zap.Reflect("logData", args))
	//返回消息
	b, _ := json.Marshal(resData)
	return c.String(200, string(b))
}