package cmd

import (
	"go-cloudprint-callback/router"

	"github.com/urfave/cli"
	"github.com/labstack/echo"
	"github.com/labstack/echo/middleware"
	"github.com/sunmi-OS/gocore/viper"
)

func RunApi(c *cli.Context) error {
	// Echo instance
	e := echo.New()

	// Middleware
	e.Use(middleware.Logger())
	e.Use(middleware.Recover())
	e.Use(middleware.BodyLimit("2M"))

	// Route => handler
	router.Router(e)

	// Start server
	return e.Start(viper.C.GetString("system.HttpApiServiceHost") + viper.C.GetString("system.HttpApiServicePort"))
}