package main

import (
    "os"
    "sort"
    "math/rand"
    "time"
    "fmt"

    "go-cloudprint-callback/cmd"

    "github.com/sunmi-OS/gocore/gorm"
    "github.com/sunmi-OS/gocore/viper"
    "github.com/urfave/cli"
)

const banner string = `
   __ _                    _                       _     
  / _* |   ___     ___    | |_     ___     ___    | |_
  \__, |  / _ \   |___|   |  _|   / -_)   (_-<    |  _|
  |___/   \___/            \__|   \___|   /__/     \__|
`

const version string = "0.0.1"

func main() {
    // 打印log
    fmt.Print(banner)

    //获取系统环境变量
    RUN_TIME := os.Getenv("RUN_TIME")
    if RUN_TIME == "" {
        panic("No RUN_TIME Can't start")
    }
    // 初始化配置文件
    viper.NewConfig("config", RUN_TIME)
    // 初始化数据库
    gorm.NewDB("dbDefault")

    rand.Seed(time.Now().Unix())
    app := cli.NewApp()
    app.Name = "go-cloudprint-callback"
    app.Usage = "go-cloudprint-callback"
    app.Email = "liyafei@sunmi.com"
    app.Version = version
    app.Usage = "go-cloudprint-callback"
    // 指定对于的命令
    app.Commands = []cli.Command{
        {
            Name:    "api",
            Aliases: []string{"a"},
            Usage:   "合作伙伴API",
            Subcommands: []cli.Command{
                {
                    Name:   "start",
                    Usage:  "合作伙伴API",
                    Action: cmd.RunApi,
                },
            },
        },
    }

    sort.Sort(cli.FlagsByName(app.Flags))
    sort.Sort(cli.CommandsByName(app.Commands))
    app.Run(os.Args)
}
